﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Microsoft.Data.SqlClient;
using System.Configuration;
namespace DbTableCreate
{
    public partial class Form2 : Form, IDisposable
    {
        private SqlCommand cmd;
        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e)
        {

            if (Form1.conn.State == ConnectionState.Closed)
            {
                Form1.conn.ConnectionString = Form1.ConnectionString;
                Form1.conn.Open();
            }

            // 표준 스키마를 통해 DB에 있는 모든 테이블 목록을 조회합니다.
            string[] conString = Form1.ConnectionString.Split(';');
            string dbName = conString[3].Split('=')[1];
            string query = "select TABLE_NAME from information_schema.tables WHERE TABLE_CATALOG = '" + dbName + "'";
            using (cmd = new SqlCommand(query, Form1.conn))
            {
                using (SqlDataReader sqlDataReader = cmd.ExecuteReader())
                {
                    // 테이블 목록을 불러와서 COMBO BOX에 저장합니다.
                    while (sqlDataReader.Read())
                    {
                        cb_tableName.Items.Add(sqlDataReader.GetString(0));
                    }
                }
            }
            // 만약 USER라는 테이블이 있다면 DEFAULT 값으로 지정하고 비활성화 합니다. 
            for (int i = 0; i < cb_tableName.Items.Count; i++)
            {
                if (cb_tableName.Items[i].ToString() == "USER")
                {
                    cb_tableName.SelectedIndex = i;
                    cb_tableName.Enabled = false;
                }
            }
            if (cb_tableName.Enabled != false)
            {
                MessageBox.Show("USER 테이블이 존재하지 않습니다. 테이블을 생성해주세요.");
                btn_cancel_Click(sender, e);
            }
        }

        private void btn_insert_Click(object sender, EventArgs e)
        {
            SqlCommand cmd2 = new SqlCommand();
            cmd2.Connection = Form1.conn;

            // 먼저 모든 데이터가 제대로 입력되었는지 확인 (공백일경우 돌아가기)
            if (tb_id.Text == "" || tb_name.Text == "" || tb_age.Text == "" || tb_address.Text == "")
            {
                MessageBox.Show("모든 데이터를 입력해주세요.", "Data 누락");
                return;
            }
            else // 공백이 없다면 모든 sql prameter 형태로 저장 
            {
                //@Id 파라미터 준비 
                SqlParameter paraId = new SqlParameter("Id", SqlDbType.VarChar, 50);
                paraId.Value = tb_id.Text;

                // Name 파라미터 준비
                SqlParameter paraName = new SqlParameter("Name", SqlDbType.NVarChar, 50);
                paraName.Value =tb_name.Text;

                // Age 파라미터 준비
                SqlParameter paraAge = new SqlParameter("Age", SqlDbType.TinyInt);
                paraAge.Value = tb_age.Text;

                // Address 파라미터 준비
                SqlParameter paraAddress = new SqlParameter("Address", SqlDbType.NVarChar);
                paraAddress.Value = tb_address.Text;

                // Birth 파라미터 준비
                SqlParameter paraBirth = new SqlParameter("Birth", SqlDbType.Date);
                paraBirth.Value = dtp_birth.Value.ToString("yyyy-MM-dd");

                // cmd.Parameters 컬렉션에 SqlParameter 개체 추가
                cmd2.Parameters.Add(paraId);
                cmd2.Parameters.Add(paraName);
                cmd2.Parameters.Add(paraAge);
                cmd2.Parameters.Add(paraAddress);
                cmd2.Parameters.Add(paraBirth);
                                
                cmd2.CommandText = "INSERT INTO [DBO].[" + cb_tableName.SelectedItem + "] (ID, NAME, AGE, ADDRESS, BIRTH) VALUES (@Id, @Name, @Age, @Address, @Birth);";
                // 정상적으로 쿼리문이 입력되면 반영된 행의 수가 리턴값으로 들어온다.
                int a = cmd2.ExecuteNonQuery();
                if (a > 0)
                {
                    MessageBox.Show(String.Format("쿼리문이 정상적으로 입력되었습니다. 반영된 행의 갯수는 {0}개 입니다", a));
                    tb_id.Text = tb_age.Text = tb_address.Text = tb_name.Text = "";
                }
                else MessageBox.Show("쿼리문이 반영되지 않았습니다. 다시 한번 확인해주세요.");
            }
        }

        private void btn_cancel_Click(object sender, EventArgs e)
        {
            Form1.conn.Close();
            this.Close();
        }
    }
}
